entity cond_add is

	generic(WIDTH: positive := 6);

	port(	x:	in	bit_vector(WIDTH-1 downto 0);
			y:	in	bit_vector(WIDTH-1 downto 0);
			cond: in bit;
			z:	out bit_vector(WIDTH-1 downto 0));
			
end entity cond_add;

library bv_utilities; use bv_utilities.bv_arithmetic.all;


architecture mixed1 of cond_add is

	signal x_r:			bit_vector(WIDTH-1 downto 0);
	signal s	 : 		bit_vector(WIDTH-1 downto 0);

begin

	x_r <= x srl 1;
	
	add: process(x_r, y) is
		variable x_i: natural;
		variable y_i: natural;
		variable s_i: integer;
	begin
		x_i := bv_to_natural(x_r);
		y_i := bv_to_natural(y);
		s_i := x_i + y_i;
		s <= integer_to_bv(s_i, WIDTH);
	end process add;
	
	mux: process(x_r, s, cond) is
	begin
		case cond is
			when '0' =>
				z <= x_r;
			when '1' =>
				z <= s;
		end case;
	end process mux;
	
end architecture mixed1;






