entity float_mult is

	generic(F_WIDTH: positive := 6;
			E_WIDTH: positive := 3);			

	port(	fa, fb: in bit_vector(F_WIDTH-1 downto 0);
			ea, eb: in bit_vector(E_WIDTH-1 downto 0);
			sa, sb: in bit;
			
			fp: out bit_vector(F_WIDTH-1 downto 0);
			ep: out bit_vector(E_WIDTH-1 downto 0);
			sp: out bit;
			ov: out bit);

end entity float_mult;


architecture structure1 of float_mult is

	signal produkt_mant: bit_vector(F_WIDTH+1 downto 0);
	signal norm: bit;
	
begin

	compute_mantissa: entity work.mult_mant
		generic map(F_WIDTH)
		port map(faktor1_frac	=> fa,
					faktor2_frac	=> fb,
					produkt_mant	=> produkt_mant);
	
	norm_mantissa: entity work.norm_mant
		generic map(F_WIDTH)
		port map(mant			=> produkt_mant,
					fract			=> fp,
					norm			=> norm);
	
	compute_exponent: entity work.comp_exp
		generic map(E_WIDTH)
		port map(faktor1_exp		=> ea,
					faktor2_exp		=> eb,
					norm				=> norm,
					produkt_exp		=> ep,
					ov					=> ov);
	
	compute_sign: entity work.comp_sign
		port map(faktor1_sign	=> sa,
					faktor2_sign	=> sb,
					produkt_sign	=> sp);
						
end architecture structure1;

